#version 330

// Input vertex attributes (from vertex shader)
in vec2 fragTexCoord;
in vec4 fragColor;

// Input uniform values
uniform sampler2D texture0;
uniform vec4 colDiffuse;

// Output fragment color
out vec4 finalColor;

uniform float Seconds;
uniform float strength;


void main() {
    vec2 uv = fragTexCoord.xy;

	float amount = 0.0;
	
	amount = (1.0 + sin(Seconds*4.0)) * 0.5;
	amount *= 1.0 + sin(Seconds*13.0) * 0.5;
	amount *= 1.0 + sin(Seconds*21.0) * 0.5;
	amount *= 1.0 + sin(Seconds*31.0) * 0.5;
	amount = pow(amount, 3.0);

	amount *= strength;
	
    vec3 col;
    col.r = texture( texture0, vec2(uv.x+amount,uv.y) ).r;
    col.g = texture( texture0, uv ).g;
    col.b = texture( texture0, vec2(uv.x-amount,uv.y) ).b;

	col *= (1.0 - amount * 0.5);
	
    finalColor = vec4(col, texture( texture0, uv ).a);
}
