#version 330

// Input vertex attributes (from vertex shader)
//
in vec2 fragTexCoord;


// Input uniform values
//
uniform sampler2D texture0;


// Output fragment color
//
out vec4 finalColor;


// Parameters supplied by calling code
//
uniform float seconds;
uniform float strength;


void main() {
    vec2 uv = fragTexCoord.xy;

    float shift = 0.0;
	
    shift = (1.0 + sin(seconds *  4.0)) * 0.5;
    shift *= 1.0 + sin(seconds * 13.0) * 0.5;
    shift *= 1.0 + sin(seconds * 21.0) * 0.5;
    shift *= 1.0 + sin(seconds * 31.0) * 0.5;
    shift = pow(shift, 3.0);

    shift *= strength;
	
    vec3 col;
    col.r = texture(texture0, vec2(uv.x + shift, uv.y)).r;
    col.b = texture(texture0, vec2(uv.x - shift, uv.y)).b;
    col.g = texture(texture0, uv).g;

    col *= (1.0 - shift * 0.5);
	

    // Add alpha into final color, so it's not warped by above
    //
    finalColor = vec4(col, texture(texture0, uv).a);
}
